export const JSX = {
    createElement(tag, attributes, ...children) {
        let elt;
        if (typeof tag === 'string')
            elt = document.createElement(tag);
        else if (tag === ShadowJsx)
            return new ShadowJsx(children, attributes);
        else
            elt = new tag();
        for (const name in attributes) {
            const attr = attributes[name];
            if (typeof attr === 'function')
                elt[name] = attr;
            else if (attr != null)
                elt.setAttribute(name, attr);
        }
        if (tag === 'template') {
            for (const child of children)
                if (child != null)
                    JSX.appendChildren(elt.content, child);
        }
        else {
            for (const child of children)
                if (child != null)
                    JSX.appendChildren(elt, child);
        }
        return elt;
    },
    appendChildren(elt, children) {
        var _a;
        if (Array.isArray(children))
            children.forEach(ch => JSX.appendChildren(elt, ch));
        else if (children instanceof Node)
            elt.appendChild(children);
        else if (children != null) {
            if (children.constructor === ShadowJsx) {
                if (elt instanceof Element) {
                    const sr = elt.shadowRoot || elt.attachShadow(((_a = children.attributes) === null || _a === void 0 ? void 0 : _a.init) || { mode: 'open' });
                    JSX.appendChildren(sr, children.children);
                }
            }
            else
                elt.appendChild(document.createTextNode(children));
        }
    }
};
export class ShadowJsx {
    constructor(children, attributes) {
        this.children = children;
        this.attributes = attributes;
    }
}
