import { JSX } from "./jsx.js";
import { dateFmt, dateShortFmt, dateShortTimeFmt, dateTimeFmt, dateYearFmt, translateDt, getBlocSolUrl, openPage, timeFmt, translateTime } from "./webapp.js";
export class Link extends HTMLElement {
    constructor() {
        super();
        this.tabIndex = 0;
        this.onclick = this.onClick;
    }
    async onClick(ev) {
        const visObj = await openPage(this.getAttribute("href"));
        if (visObj) {
            if (!notNowDialog) {
                notNowDialog = document.createElement("dialog");
                notNowDialog.addEventListener("click", function () { this.close(); });
                document.body.appendChild(notNowDialog);
            }
            const date = translateDt(visObj.vis, dateTimeFmt);
            notNowDialog.replaceChildren(JSX.createElement("h3", null, visObj.ti), JSX.createElement("p", null, `Prochainement disponible : ${date}`));
            notNowDialog.showModal();
        }
    }
}
let notNowDialog = null;
customElements.define('p-link', Link);
export class Sol extends HTMLElement {
    connectedCallback() {
        this.refresh();
    }
    async refresh() {
        const url = getBlocSolUrl(this.getAttribute("id"));
        if (url) {
            this.hidden = false;
            this.innerHTML = await (await fetch(url)).text();
        }
        else {
            this.hidden = true;
        }
    }
}
customElements.define('p-sol', Sol);
export class DateTime extends HTMLElement {
    connectedCallback() {
        this.textContent = translateDt(this.getAttribute("date"), this.getFmt());
    }
    getFmt() {
        switch (this.getAttribute("format")) {
            case "time":
                return timeFmt;
            case "date":
                return dateFmt;
            case "dateTime":
                return dateTimeFmt;
            case "dateShort":
                return dateShortFmt;
            case "dateShortTime":
                return dateShortTimeFmt;
            case "dateYear":
                return dateYearFmt;
            default:
                return dateTimeFmt;
        }
    }
}
customElements.define('p-dt', DateTime);
export class Time extends HTMLElement {
    connectedCallback() {
        this.textContent = translateTime(this.getAttribute("time"));
    }
}
customElements.define('p-time', Time);
