import { makeButton } from "./commons.js";
export class TabButton extends HTMLElement {
    constructor() {
        super();
        makeButton(this);
        this.addEventListener("keypress", (ev) => {
            if (ev.key === "ArrowLeft") {
                this.selOtherTab(true);
            }
            else if (ev.key === "ArrowRight") {
                this.selOtherTab(false);
            }
        });
    }
    selOtherTab(before) {
        const other = before ? this.previousElementSibling : this.nextElementSibling;
        if (other instanceof TabButton)
            other.onClick();
    }
    onClick() {
        const root = this.getRootNode();
        for (let t = this.parentElement.firstElementChild; t; t = t.nextElementSibling) {
            t.setAttribute("aria-selected", (t === this).toString());
            root.getElementById(t.getAttribute("aria-controls")).hidden = t !== this;
        }
    }
}
customElements.define('p-tab', TabButton);
